QuantLib: MCPagodaEngine< RNG, S > Class Template Reference

A free/open-source library for quantitative finance Reference manual - version 1.20

Public Types | Public Member Functions | List of all members
MCPagodaEngine< RNG, S > Class Template Reference

Pricing engine for pagoda options using Monte Carlo simulation. More...

`#include <ql/experimental/exoticoptions/mcpagodaengine.hpp>`

Inheritance diagram for MCPagodaEngine< RNG, S >:
[legend]

## Public Types
typedef McSimulation< MultiVariate, RNG, S >::path_generator_type | path_generator_type
typedef McSimulation< MultiVariate, RNG, S >::path_pricer_type | path_pricer_type
typedef McSimulation< MultiVariate, RNG, S >::stats_type | stats_type
Public Types inherited from Observer
typedef boost::unordered_set< ext::shared_ptr< Observable > > | set_type
typedef set_type::iterator | iterator
Public Types inherited from McSimulation< MultiVariate, PseudoRandom, Statistics >
typedef MonteCarloModel< MultiVariate, PseudoRandom, Statistics >::path_generator_type | path_generator_type
typedef MonteCarloModel< MultiVariate, PseudoRandom, Statistics >::path_pricer_type | path_pricer_type
typedef MonteCarloModel< MultiVariate, PseudoRandom, Statistics >::stats_type | stats_type
typedef MonteCarloModel< MultiVariate, PseudoRandom, Statistics >::result_type | result_type

## Public Member Functions
| MCPagodaEngine (const ext::shared_ptr< StochasticProcessArray > &, bool brownianBridge, bool antitheticVariate, Size requiredSamples, Real requiredTolerance, Size maxSamples, BigNatural seed)
void | calculate () const
Public Member Functions inherited from GenericEngine< PagodaOption::arguments, PagodaOption::results >
PricingEngine::arguments * | getArguments () const
const PricingEngine::results * | getResults () const
void | reset ()
void | update ()
Public Member Functions inherited from PricingEngine
virtual arguments * | getArguments () const =0
virtual const results * | getResults () const =0
Public Member Functions inherited from Observable
| Observable (const Observable &)
Observable & | operator= (const Observable &)
void | notifyObservers ()
Public Member Functions inherited from Observer
| Observer (const Observer &)
Observer & | operator= (const Observer &)
std::pair< iterator, bool > | registerWith (const ext::shared_ptr< Observable > &)
void | registerWithObservables (const ext::shared_ptr< Observer > &)
Size | unregisterWith (const ext::shared_ptr< Observable > &)
void | unregisterWithAll ()
virtual void | deepUpdate ()
Public Member Functions inherited from McSimulation< MultiVariate, PseudoRandom, Statistics >
result_type | value (Real tolerance, Size maxSamples=QL_MAX_INTEGER, Size minSamples=1023) const
| add samples until the required absolute tolerance is reached
result_type | valueWithSamples (Size samples) const
| simulate a fixed number of samples
result_type | errorEstimate () const
| error estimated using the samples simulated so far
const stats_type & | sampleAccumulator () const
| access to the sample accumulator for richer statistics
void | calculate (Real requiredTolerance, Size requiredSamples, Size maxSamples) const
| basic calculate method provided to inherited pricing engines

## Additional Inherited Members
Protected Member Functions inherited from McSimulation< MultiVariate, PseudoRandom, Statistics >
| McSimulation (bool antitheticVariate, bool controlVariate)
virtual ext::shared_ptr< path_pricer_type > | pathPricer () const=0
virtual ext::shared_ptr< path_generator_type > | pathGenerator () const=0
virtual TimeGrid | timeGrid () const=0
virtual ext::shared_ptr< path_pricer_type > | controlPathPricer () const
virtual ext::shared_ptr< path_generator_type > | controlPathGenerator () const
virtual ext::shared_ptr< PricingEngine > | controlPricingEngine () const
virtual result_type | controlVariateValue () const
Static Protected Member Functions inherited from McSimulation< MultiVariate, PseudoRandom, Statistics >
static Real | maxError (const Sequence &sequence)
static Real | maxError (Real error)
Protected Attributes inherited from GenericEngine< PagodaOption::arguments, PagodaOption::results >
PagodaOption::arguments | arguments_
PagodaOption::results | results_
Protected Attributes inherited from McSimulation< MultiVariate, PseudoRandom, Statistics >
ext::shared_ptr< MonteCarloModel< MultiVariate, PseudoRandom, Statistics > > | mcModel_
bool | antitheticVariate_
bool | controlVariate_

## Detailed Description

### template<class RNG = PseudoRandom, class S = Statistics>
class QuantLib::MCPagodaEngine< RNG, S >

Pricing engine for pagoda options using Monte Carlo simulation.